#import <Foundation/Foundation.h>

#pragma makr - Declare Enumerlator

typedef enum {
    AsReaderP252BResultNoError = 0x0000,
    AsReaderP252BResultOtherError = 0x0001,
    AsReaderP252BResultUndefined = 0x0002,
    AsReaderP252BResultMemoryOverrun = 0x0003,
    AsReaderP252BResultMemoryLocked = 0x0004,
    AsReaderP252BResultInsufficientPower = 0x000B,
    AsReaderP252BResultNotConnected = 0xE100,
    AsReaderP252BResultInvalidParameter = 0xE200,
    AsReaderP252BResultTimeout = 0xEFFF,
    AsReaderP252BResultHandleMismatch = 0xF001,
    AsReaderP252BResultCRCError = 0xF002,
    AsReaderP252BResultCommandFormatError = 0xF007,
    AsReaderP252BResultOutOfRetries = 0xF009,
} AsReaderP252BResultCode;

typedef enum {
    AsReaderP252BBank_Reserved,
    AsReaderP252BBank_EPC,
    AsReaderP252BBank_TID,
    AsReaderP252BBank_User
} AsReaderP252BMemoryBank;

typedef enum {
    AsReaderP252BTemperatureTagType_0 = 0,//Magnus -S3
    AsReaderP252BTemperatureTagType_1,
    AsReaderP252BTemperatureTagType_2,
    AsReaderP252BTemperatureTagType_3,
    AsReaderP252BTemperatureTagType_4
} AsReaderP252BTemperatureTagType;

typedef enum {
    AsReaderP252BBuzzer_Off,
    AsReaderP252BBuzzer_Low,
    AsReaderP252B3Buzzer_High
} AsReaderP252BBuzzerState;
 
typedef enum {
    AsReaderP252BSession_S0,
    AsReaderP252BSession_S1,
    AsReaderP252BSession_S2,
    AsReaderP252BSession_S3
} AsReaderP252BSessionType;

typedef enum {
    AsReaderP252BSessionFlag_A,
    AsReaderP252BSessionFlag_B,
    AsReaderP252BSessionFlag_AB
} AsReaderP252BSessionFlag;
 
typedef struct {
    int min;
    int max;
} AsReaderP252BMinMaxValue;
 
@interface AsReaderP252BLockParam : NSObject

@property (nonatomic) BOOL killPassword;
@property (nonatomic) BOOL accessPassword;
@property (nonatomic) BOOL epc;
@property (nonatomic) BOOL tid;
@property (nonatomic) BOOL user;

- (int)value;

@end
 
@interface AsReaderP252BResultData : NSObject

- (id)initWithResultCode:(AsReaderP252BResultCode)result data:(NSData *)data;
- (AsReaderP252BResultCode)result;
- (NSData *)data;

@end
 
@interface AsReaderP252BSelectMaskEPCParam : NSObject<NSCoding>

@property (nonatomic) int offset;
@property (nonatomic) int length;
@property (strong, nonatomic) NSString *mask;

@end

@interface AsReaderP252BLbtItem : NSObject <NSCoding>

@property (nonatomic) int mSlot;
@property (nonatomic) BOOL mIsUsed;
@property (strong, nonatomic) NSString *frequency;

-(id)init;
-(id)initWithSlot:(int)slot isUsed:(BOOL)isUsed frequency:(NSString *)frequency ;

@end
